@use 'sass:map';
@use 'sass:math';
// para usar los métodos built-in de map agregamos la línea de arriba, que debe ser la primer línea de nuestro archivo sass, para
// poder agregar get y set

// en sass las importaciones son de mejor rendimiento que en css, esto es porque para hacer la importacion del contenido de css, no
//es necesario para nuestra página que descargue el archivo css que queremos importar al navegador del cliente
//, en vez de eso se puede solo cargar 1 archivo css que es el archivo sass transpilado
//por ejemplo, aquí debajo estamos importando typography, y en la versión transpilada de este código, esto hace que el código de typography
//se incruste en la sección donde se importa, y debajo estamos importando las variables, como las variables son algo
//que no se convierte a css normal, en esa sección no se agregará nada, solamente se tendrá el acceso, a los valores
//de las variables para poder usarlas en la versión transpilada de nuestro código
@import 'typography';

@import 'variables';

// ahora vamos a usar los mixin, los mixin son una especie de funciones por decirlo de algún modo, que contienen dentro
//código sass, que será renderizado en el lugar donde se llamen estos mixin, son snippets de código, por decirlo de algún
//otro modo, por ejemplo aquí abajo este mixin, donde se llame será reemplazado por el código que contiene, es la forma más
//sencilla de mixin donde funciona más como un snippet plano de código
@mixin display-flex() {
	display: -webkit-box;
	display: -ms-flexbox;
	display: -webkit-flex;
	display: flex;
}

//esta es otra forma de llamar a los mixin, donde podemos recibir parámetros, en el parentesis listamos el nombre del parámetro
//que queremos recibir, en este caso es una variable de nombre width, que será el ancho a usar en el mixin, y el contenido
//del mixin en este caso es una media query, queremos que al hacer uso del mixin le podamos enviar contenido, por lo cual
//usamos la directiva @content, dentro de nuestro media query, y esa directiva será reemplazada por el cuerpo de
//código actual que enviemos al hacer uso de nuestro mixin
@mixin media-min-width($width) {
	@media (min-width: $width) {
		// font-size: 125%;
		@content;
	}
}

html {
	font-size: 94.75%;
	// al declarar la media query dentro de nuestro selector, sin enviar nada más que los atributos que
	// queremos modificar en esa media query, automáticamente sass se encarga de crear una media query donde
	//los atributos que modificamos se apliquen al elemento html donde estamos, osea se crea la regla en este caso
	//del media query que afecta al elemento html
	// @media (min-width: 40rem) {
	// 	font-size: 125%;
	// }

	// así hacemos uso de nuestro mixin, usamos la directiva @include, con el nombre del mixin, y en este caso recibe un parámetro
	//así que lo enviamos, además recibe contenido así que también lo enviamos entre llaves, esto inyectará en esta clase
	//el valor del mixin de acuerdo a los parámetros que le enviamos
	@include media-min-width(40rem) {
		font-size: 125%;
	}
	// esto es una manera mas facil que tenemos para tener cerca nuestros media querys del selector
	//que estamos usando para agregar o modificar sus estilos,sin usar esta sintaxis
	//tendriamos que hacer algo como lo siguiente, declarando la lista de cada elemento que queremos modificar, con
	// sus respectivos atributos  dentro
	// @media (min-width: 40rem) {
	// 	html{
	// 		font-size: 125%;
	//	 }
	// }
}

body {
	font-family: Arial, sans-serif;
	margin: 0;
}

.container {
	// esta es la forma de usar una directiva sencilla, simplemente debemos usar la directiva @include, y el nombre
	//del mixin que queremos usar, esto inyectará en esta clase el valor del mixin, en este caso será un mixin de valor fijo, ya que
	//no recibe parámetros y solo inyecta contenido fijo de sass
	@include display-flex();
	// el contenido que inyecta es esta lista de displays
	// display: -webkit-box;
	// display: -ms-flexbox;
	// display: -webkit-flex;
	// display: flex;
	// flex-direction: column;
	// flex-wrap: nowrap;
	// en sass tenemos también la posibilidad de agregar ademas de selectores anidados, propiedades anidadas
	// es decir, de una propiedad principal agregar sus descendientes, por ejemplo para usar flex-direction y flex-wrap
	//ambas son descendientes de flex, y podríamos usarlas como se muestra a continuación, lo que nosayudaría a
	//tener más explícito nuestro código, y a no escribir tantas veces la palabra flex, y a detectar de forma más
	// rápida que atributos pertenecen a que propiedad general
	flex: {
		direction: column;
		wrap: nowrap;
	}
	align-items: center;
	// padding: 3rem 0;
	// sass nos permite hacer operaciones aritméticas, esto nos da mayor dinamismo y podemos usarlo para aquellos valores que son
	//dependientes de otros, en este caso el padding de este elemento, guarda cierta relación con el valor de nuestros margin de
	//otras secciones, para que este padding siempre sea más grande, podemos multiplicar el valor de la otra unidad de medida que usamos
	//por un número entero y el resultado será un valor que es dependiente de otro y a su vez aseguramos que será más grande que el valor
	//del cual depende y con ello aseguramos la consistencia en el diseño, podemos aplicar operaciones como multiplicaciones,
	//sumas, restas y divisiones
	padding: $size-default * 3 0;
	box-sizing: border-box;
}

.sass-section {
	border: $border-default;
	background: lighten(map-get($colors, main), 72%);
	padding: $size-default * 2;
	text-align: center;
	width: 90%;
	box-sizing: border-box;
	// @media (min-width: 40rem) {
	// 	width: 30rem;
	// }
	@include media-min-width(40rem) {
		width: 30rem;
	}
}

// otra propiedad interesante que se puede usar en sass, es la herencia de propiedades, anteriormente, en este código
//teniamos varias propiedades que eran compartidas por dos clases en específico, para ahorrrarnos el tener que escribir el código
//una y otra vez, podemos crear una clase adicional que contenga nuestros estilos compartidos, y heredar esos estilos
//a su vez en otra clase, de este modo la nueva clase que creemos, tendrá todos los estilos de la clase que estamos heredando, además
//de agregar los que son exclusivos de ese selector, es una herramienta muy util para ahorrarnos el escribir mucho codigo,
//la clase que escribimos arriba (.sass-section) es una clase de la cual vamos a heredar sus estilos en otra clase

.sass-introduction {
	// heredamos los estilos de sass-section usando @extend para que se apliquen a este selector, y definimos el estilo
	//exclusivo de este selector que es el box shadow
	@extend .sass-section;
	box-shadow: $size-tiny $size-tiny math.div($size-tiny, 2) #ccc;
	p {
		margin: 0;
	}
}

.sass-details {
	// heredamos los estilos de sass-section usando @extend para que se apliquen a este selector, y definimos el estilo
	//exclusivo de este selector que es el margin
	@extend .sass-section;
	margin: $size-default * 2 0;
}

// .sass-introduction p {
// 	margin: 0;
// }

.section-header {
	border-bottom: $border-default;
	h1 {
		margin: 0 0 $size-default 0;
	}
}

// .section-header h1 {
// 	margin: 0 0 $size-default 0;
// }

// con sass podemos agregar lo que es conocido como nesting, es decir
// a un selector de css le podemos poner sus descendientes, directamente dentro del mismo selector
// sin tener que crear otro selector por cada descendiente que queremos tener

// para declarar nuestro nesting creamos nuestra clase selectora principal que va a contener
// a nuestros otros selectores, al final este código de sass que no es entendible por el navegador, se va
//convertir a código css normal; sass, al final es una herramienta de desarrollo únicamente
.documentation-links {
	list-style: none;
	margin: $size-default 0 0 0;
	padding: 0;
	// display: -webkit-box;
	// display: -ms-flexbox;
	// display: -webkit-flex;
	// display: flex;
	@include display-flex();
	flex-direction: column;

	li {
		margin: $size-tiny 0;
		background: white;
	}

	.documentation-link {
		text-decoration: none;
		// de esta forma se accedia a los valores de mapas anteriormente, esta función ahora se puede cambiar por la función map.get
		//pero para la cual hay que importar las built-in functions de map, es mas conveniente usar map.get porque es una sintaxis
		//más corta
		color: map-get($map: $colors, $key: main);
		display: block;
		padding: $size-tiny;
		border: $border-default;
		// aquí estamos haciendo refactorización, automáticamente sass al agregar un selector descendiente dentro de otro
		//lo agregará como nesting, pero podemos cambiar ese comportamiento, si agregamos un ampersand (&) a nuestros selectores,
		//en vez de indicar nesting, le indicamos que deberán estar conectados, es decir, aquí en vez de comportarse como 
		//.documentation-link :hover lo hará como .documentation-link:hover, y esto es importante porque con ese espacio añadido,
		//no estariamos usando nuestro elemento como pseudoselector, sino como un selector descendiente, por lo tanto
		// las funciones hover y active no funcionarían como esperamos
		&:hover,
		&:active {
			color: white;
			background: map.get($colors, secondary);
			border-color: map-get($map: $colors, $key: secondary);
		}
	}

	// .documentation-link:hover,
	// .documentation-link:active {
	// 	color: white;
	// 	background: map.get($colors, secondary);
	// 	border-color: map-get($map: $colors, $key: secondary);
	// }
}

// este código de abajo es el que nos estamos ahorrando, al poder anidar
// todo ese código en un selector principal que comparten todos estos elementos

// .documentation-links li {
// 	margin: 0.2rem 0;
// 	background: white;
// }

// .documentation-links .documentation-link {
// 	text-decoration: none;
// 	color: #521751;
// 	display: block;
// 	padding: 0.2rem;
// 	border: 0.05rem solid #521751;
// }

// .documentation-links .documentation-link:hover,
// .documentation-links .documentation-link:active {
// 	color: white;
// 	background: #fa923f;
// 	border-color: #fa923f;
// }

// en sass podemos hacer uso de las media queries de diferente forma
//tenemos la forma tradicional de declarar media queries que ya conocemos, y tenemos otra forma, donde podemos
// declarar la media query, dentro del selector que queremos que la media query afecte, esto se muestra a más detalle en las líneas superiores
@media (min-width: 40rem) {
	// html {
	// 	font-size: 125%;
	// }

	.container {
		padding: 3rem 0;
	}

	// .sass-introduction,
	.sass-details {
		width: 30rem;
	}
}
